// How to use
//
// root [0] .x fit_brho.cc
//
//

const Int_t Nvar=6;
Int_t neve=2000;
//Int_t neve=-1;
//____________________________________________________________________
void fit_brho()
{
  TFile *file = new TFile("root/examples/brho_func/fit_brho_out.root","recreate");
  // Global data parameters 
  // make fit object and set parameters on it. 
  TMultiDimFit *MDFit = new TMultiDimFit(Nvar, TMultiDimFit::kMonomials,"v");
  TString filename("root/examples/brho_func/analyzed.root");
  SetData(MDFit,filename);
  FitData(MDFit);
  CheckFunc(filename,file);
  file->Write();

  delete MDFit;
  std::cout<<"\a"<<std::endl;
}
//____________________________________________________________________
void SetData(TMultiDimFit *MDFit, TString filename)
{
  std::cout<<"start SetData ...."<<std::endl;

  ifstream fin;
  fin.open(filename.Data());
  if (!fin.good()) {
    cerr<<"Cannot open file: "<<filename.Data()<<endl;
    return;
  }
  TFile file(filename.Data(),"readonly");
  TTree *tree = (TTree*)file.Get("tree");
  Double_t brho;
  Double_t fdc1x,fdc1y,fdc1a,fdc1b;
  Double_t fdc2x,fdc2y,fdc2a,fdc2b;
  Double_t fl;
  tree->SetBranchAddress("brho",&brho);  
  tree->SetBranchAddress("fdc1xsim",&fdc1x);
  tree->SetBranchAddress("fdc1asim",&fdc1a);
  tree->SetBranchAddress("fdc1ysim",&fdc1y);
  tree->SetBranchAddress("fdc1bsim",&fdc1b);
  tree->SetBranchAddress("fdc2xsim",&fdc2x);
  tree->SetBranchAddress("fdc2asim",&fdc2a);
  tree->SetBranchAddress("fdc2ysim",&fdc2y);
  tree->SetBranchAddress("fdc2bsim",&fdc2b);
  tree->SetBranchAddress("flsim",&fl);

  Int_t n=neve;
  if (neve<0) n = tree->GetEntries();
  for (int i=0;i<n;++i){
    tree->GetEntry(i);
    Double_t x[Nvar]={fdc1x,fdc1a,fdc1y,fdc1b,fdc2x,fdc2a};
    MDFit->AddRow(x,brho,0.1);
    MDFit->AddTestRow(x,brho,0.1);
  }
  return;
}
//____________________________________________________________________
void CheckFunc(TString filename, TFile *ofile)
{
  std::cout<<"start CheckFunc ...."<<endl;
  //gROOT->ProcessLine(".L MakeMDF.cc++g");
  gROOT->ProcessLine(".L MDF.C");

  TFile file(filename.Data(),"readonly");
  TTree *tree = (TTree*)file.Get("tree");
  Double_t brho;
  Double_t fdc1x,fdc1y,fdc1a,fdc1b;
  Double_t fdc2x,fdc2y,fdc2a,fdc2b;
  Double_t fl;
  tree->SetBranchAddress("brho",&brho);  
  tree->SetBranchAddress("fdc1xsim",&fdc1x);
  tree->SetBranchAddress("fdc1asim",&fdc1a);
  tree->SetBranchAddress("fdc1ysim",&fdc1y);
  tree->SetBranchAddress("fdc1bsim",&fdc1b);
  tree->SetBranchAddress("fdc2xsim",&fdc2x);
  tree->SetBranchAddress("fdc2asim",&fdc2a);
  tree->SetBranchAddress("fdc2ysim",&fdc2y);
  tree->SetBranchAddress("fdc2bsim",&fdc2b);
  tree->SetBranchAddress("flsim",&fl);  

  ofile->cd();
  TTree* otree = new TTree("tree","fit result");
  Double_t brho_fun;
  otree->Branch("fdc1x",&fdc1x,"fdc1x/D");
  otree->Branch("fdc1a",&fdc1a,"fdc1a/D");
  otree->Branch("fdc1y",&fdc1y,"fdc1y/D");
  otree->Branch("fdc1b",&fdc1b,"fdc1b/D");
  otree->Branch("fdc2x",&fdc2x,"fdc2x/D");
  otree->Branch("fdc2a",&fdc2a,"fdc2a/D");
  otree->Branch("fdc2y",&fdc2y,"fdc2y/D");
  otree->Branch("fdc2b",&fdc2b,"fdc2b/D");
  otree->Branch("brho",&brho,"brho/D");
  otree->Branch("brho_fun",&brho_fun,"brho_fun/D");
  otree->Branch("fl",&fl,"fl/D");  

  TH1* hdb = new TH1D("hdb","fdBrho/Brho (%)",200,-5,5);
  TH1* hx1db = new TH2D("hx1db","fdc1x dBrho/Brho (%)",200,-200,200,  200,-2,2);
  TH1* ha1db = new TH2D("ha1db","fdc1a dBrho/Brho (%)",200,-200,200,  200,-2,2);
  TH1* hx2db = new TH2D("hx2db","fdc2x dBrho/Brho (%)",200,-1200,1200,200,-2,2);
  TH1* ha2db = new TH2D("ha2db","fdc2a dBrho/Brho (%)",200,-400,400,  200,-2,2);
  TH1* hbdb = new TH2D("hbdb","Brho dBrho/Brho (%)",200,4.5,8.5,      200,-2,2);
  TH1* hy1db = new TH2D("hy1db","fdc1y dBrho/Brho (%)",200,-200,200,  200,-2,2);
  TH1* hb1db = new TH2D("hb1db","fdc1b dBrho/Brho (%)",200,-200,200,  200,-2,2);
  TH1* hy2db = new TH2D("hy2db","fdc2y dBrho/Brho (%)",200,-500,500,  200,-2,2);
  TH1* hb2db = new TH2D("hb2db","fdc2b dBrho/Brho (%)",200,-200,200,  200,-2,2);

  Int_t n=neve;
  if (neve<0) n = tree->GetEntries();
  for (int i=0;i<n;++i){
    tree->GetEntry(i);

    Double_t x[Nvar]={fdc1x,fdc1a,fdc1y,fdc1b,fdc2x,fdc2a};
    brho_fun = MDF(x);

    Double_t db = (brho-brho_fun)/brho*100.;//%
    hdb->Fill(db);
    hx1db->Fill(fdc1x,db);
    ha1db->Fill(fdc1a,db);
    hx2db->Fill(fdc2x,db);
    ha2db->Fill(fdc2a,db);
    hbdb->Fill(brho,db);

    hy1db->Fill(fdc1y,db);
    hb1db->Fill(fdc1b,db);
    hy2db->Fill(fdc2y,db);
    hb2db->Fill(fdc2b,db);

    otree->Fill();
  }
  hdb->Fit("gaus");
}
//____________________________________________________________________
Int_t FitData(TMultiDimFit *MDFit)
{
  Int_t mPowers[Nvar]   = {4,4,4,4,4,4s};
  MDFit->SetMaxPowers(mPowers);
  MDFit->SetMinRelativeError(0.01);
  
  MDFit->SetMaxFunctions(100000);
  MDFit->SetMaxStudy(10000000);
  MDFit->SetMaxTerms(1000);
  MDFit->SetPowerLimit(1);
  MDFit->SetMinAngle(10);
  MDFit->SetMaxAngle(10);

  // Print out the start parameters
  std::cout<<"... print out the start parameters"<<std::endl;
  MDFit->Print("fcvp");


  // Print out the statistics
  std::cout<<"... print out the statistics"<<std::endl;
  MDFit->Print("s");

  // Book histograms 
  MDFit->MakeHistograms();

  // Find the parameterization 
  std::cout<<"... start FindParameterization"<<std::endl;
  MDFit->FindParameterization();

  // Print coefficents 
  MDFit->Print("rc");

  // Test the parameterizatio and coefficents using the test sample. 
  std::cout<<"... start fit"<<std::endl;
  //MDFit->Fit("M");// probably better error estimation
  MDFit->Fit();

  // Print result 
  MDFit->Print("fc");

  // Write code to file 
  std::cout<<"... start MakeCode"<<std::endl;
  MDFit->MakeCode();
  //MDFit->MakeMethod("TArtMDF_s021_Brho");//konohen nani yatteru

  // Write histograms to disk, and close file 
  //fOutput->Write();
  //fOutput->Close();
  
//  // Compare results with reference run
//  Int_t compare = CompareResults(MDFit);
//  if (!compare) {
//     printf("\nmultidimfit ..............................................  OK\n");
//  } else {
//     printf("\nmultidimfit ..............................................  fails case %d\n",compare);
//  }

  // We're done 
//  return compare;
  return 0;
}
